import { __extends, __awaiter, __generator, __assign, __spread, __read } from 'tslib';
import { Component, ChangeDetectionStrategy, ViewEncapsulation, ElementRef, HostListener, Directive, Optional, Host, Input, InjectionToken, EventEmitter, forwardRef, ViewChild, Output, Inject, ContentChild, HostBinding, TemplateRef, ViewContainerRef, Renderer2, NgZone, Pipe, NgModule } from '@angular/core';
import { trigger, transition, style, animate } from '@angular/animations';
import { BehaviorSubject, Subject, merge, EMPTY } from 'rxjs';
import { mixinDisabled, mixinGrouped, ImageConverter, mixinFocused, mixinReadonly, mixinRequired, mixinError, coerceBooleanProperty, Platform, mixinLoad } from '@bravobit/bb-foundation';
import { NG_VALUE_ACCESSOR, NgControl, FormGroupDirective } from '@angular/forms';
import { map, tap, mapTo, delay, filter } from 'rxjs/operators';
import { LocalizeModule } from '@bravobit/bb-foundation/localize';
import { DomSanitizer } from '@angular/platform-browser';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbDropdown = /** @class */ (function () {
    function BbDropdown(_elementRef) {
        this._elementRef = _elementRef;
        // State.
        this.visible$ = new BehaviorSubject(false);
    }
    /**
     * @return {?}
     */
    BbDropdown.prototype.toggle = /**
     * @return {?}
     */
    function () {
        return this.visible$.next(!this.visible$.getValue());
    };
    /**
     * @return {?}
     */
    BbDropdown.prototype.close = /**
     * @return {?}
     */
    function () {
        return this.visible$.next(false);
    };
    /**
     * @param {?} target
     * @return {?}
     */
    BbDropdown.prototype.onDocumentClick = /**
     * @param {?} target
     * @return {?}
     */
    function (target) {
        if (!target) {
            return;
        }
        if (this._elementRef.nativeElement.contains(target)) {
            return;
        }
        return this.close();
    };
    BbDropdown.decorators = [
        { type: Component, args: [{
                    selector: 'bb-dropdown',
                    template: "<button (click)=\"toggle()\"\n        [class.opened]=\"visible$ | async\"\n        type=\"button\">\n    <ng-content></ng-content>\n</button>\n\n<div *ngIf=\"visible$ | async\"\n     [@dropdownMenuAnimation]=\"true\"\n     class=\"bb-dropdown-menu\"\n     role=\"list\">\n    <ng-content select=\"[bbDropdownItem], hr\"></ng-content>\n</div>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    host: { 'class': 'bb-dropdown' },
                    preserveWhitespaces: false,
                    animations: [
                        trigger('dropdownMenuAnimation', [
                            transition(':enter', [
                                // 1. Set the initial state.
                                style({ opacity: 0, transform: 'scale(0.9)' }),
                                // 2. Start the animation to show the item.
                                animate('80ms cubic-bezier(0, 0, .2, 1)', style({ opacity: 1, transform: 'scale(1)' }))
                            ]),
                            transition(':leave', [
                                // 1. Set the initial state.
                                style({ opacity: 1, transform: 'scale(1)' }),
                                // 2. Start the animation to hide the item.
                                animate('80ms cubic-bezier(0, 0, .2, 1)', style({ opacity: 0, transform: 'scale(0.9)' }))
                            ])
                        ])
                    ],
                    styles: [".bb-dropdown{position:relative;display:inline-block}.bb-dropdown.right>.bb-dropdown-menu{right:0;left:auto;-ms-transform-origin:top right;transform-origin:top right}.bb-dropdown-menu{left:0;top:100%;padding:0;z-index:10;display:block;margin:10px 0 0;border-radius:4px;position:absolute;list-style-type:none;background-color:#fff;border:1px solid #ccc;-ms-transform-origin:top left;transform-origin:top left;box-shadow:0 0 6px 0 rgba(0,0,0,.1)}.bb-dropdown-menu:after{width:0;top:-5px;height:0;right:5px;content:\"\";position:absolute;border-style:solid;border-width:0 10px 5px;border-color:transparent transparent #d9d9d9}.bb-dropdown-menu>hr{margin:0;height:1px;border:none;background-color:#ccc}.bb-dropdown-item{width:100%;border:none;line-height:1;display:block;cursor:pointer;text-align:left;font-weight:500;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;padding:12px 20px;white-space:nowrap;text-decoration:none;color:#676767!important;background-color:transparent;transition:background-color 250ms cubic-bezier(0,0,.2,1)}.bb-dropdown-item:first-child{border-top-left-radius:4px;border-top-right-radius:4px}.bb-dropdown-item:hover{background-color:#f6f6f6}.bb-dropdown-item:focus{box-shadow:0 0 0 3px rgba(220,224,233,.5)}.bb-dropdown-item:active{background-color:#f0f0f0}"]
                }] }
    ];
    /** @nocollapse */
    BbDropdown.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    BbDropdown.propDecorators = {
        onDocumentClick: [{ type: HostListener, args: ['document:click', ['$event.target'],] }]
    };
    return BbDropdown;
}());
if (false) {
    /** @type {?} */
    BbDropdown.prototype.visible$;
    /**
     * @type {?}
     * @private
     */
    BbDropdown.prototype._elementRef;
}
var BbDropdownItem = /** @class */ (function () {
    function BbDropdownItem(_parent) {
        this._parent = _parent;
        // Inputs.
        this.closeOnClick = true;
    }
    /**
     * @return {?}
     */
    BbDropdownItem.prototype.onClick = /**
     * @return {?}
     */
    function () {
        if (!this.closeOnClick) {
            return;
        }
        this._parent && this._parent.close();
    };
    BbDropdownItem.decorators = [
        { type: Directive, args: [{
                    selector: '[bbDropdownItem]',
                    host: { 'class': 'bb-dropdown-item' }
                },] }
    ];
    /** @nocollapse */
    BbDropdownItem.ctorParameters = function () { return [
        { type: BbDropdown, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    BbDropdownItem.propDecorators = {
        closeOnClick: [{ type: Input }],
        onClick: [{ type: HostListener, args: ['click',] }]
    };
    return BbDropdownItem;
}());
if (false) {
    /** @type {?} */
    BbDropdownItem.prototype.closeOnClick;
    /**
     * @type {?}
     * @private
     */
    BbDropdownItem.prototype._parent;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var ELEMENTS_ICONS = new InjectionToken('elements_icons');
/** @type {?} */
var ELEMENTS_ERRORS = new InjectionToken('elements_errors');
/**
 * @record
 */
function ElementsIconFont() { }
if (false) {
    /** @type {?} */
    ElementsIconFont.prototype.namespace;
    /** @type {?} */
    ElementsIconFont.prototype.className;
    /** @type {?|undefined} */
    ElementsIconFont.prototype.inline;
    /** @type {?} */
    ElementsIconFont.prototype.type;
}
/**
 * @record
 */
function ElementsIconImage() { }
if (false) {
    /** @type {?} */
    ElementsIconImage.prototype.namespace;
    /** @type {?} */
    ElementsIconImage.prototype.name;
    /** @type {?} */
    ElementsIconImage.prototype.src;
    /** @type {?} */
    ElementsIconImage.prototype.type;
}
/**
 * @record
 */
function ElementsIconUnknown() { }
if (false) {
    /** @type {?} */
    ElementsIconUnknown.prototype.type;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbImagePickerBase = /** @class */ (function () {
    function BbImagePickerBase() {
    }
    return BbImagePickerBase;
}());
/** @type {?} */
var BbImagePickerMixinBase = mixinDisabled(mixinGrouped(BbImagePickerBase));
var BbImagePicker = /** @class */ (function (_super) {
    __extends(BbImagePicker, _super);
    function BbImagePicker(_converter) {
        var _this = _super.call(this) || this;
        _this._converter = _converter;
        // Inputs.
        _this.label = null;
        _this.placeholder = null;
        _this.styleDimensions = null;
        _this.cropDimensions = null;
        // Form.
        _this._value$ = new BehaviorSubject(null);
        _this.valueChange = new EventEmitter();
        _this.onTouchedCallback = (/**
         * @return {?}
         */
        function () {
        });
        _this.onChangeCallback = (/**
         * @return {?}
         */
        function () {
        });
        return _this;
    }
    Object.defineProperty(BbImagePicker.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            return this._value$.getValue();
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._value$.next(value);
            this.valueChange.emit(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbImagePicker.prototype, "image", {
        get: /**
         * @return {?}
         */
        function () {
            var _this = this;
            return this._value$.pipe(map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return value || _this.placeholder; })), map((/**
             * @param {?} value
             * @return {?}
             */
            function (value) { return value ? "url(" + value + ")" : null; })));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} event
     * @return {?}
     */
    BbImagePicker.prototype.onFileChange = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        return __awaiter(this, void 0, void 0, function () {
            var file, _a, error_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        // Grab the file from the event.
                        file = event.target.files[0];
                        // Check if the file exists.
                        if (!file || this.disabled) {
                            return [2 /*return*/];
                        }
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        _a = this;
                        return [4 /*yield*/, this._converter.toDataUri(file, this.cropDimensions)];
                    case 2:
                        _a.value = _b.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _b.sent();
                        this.value = null;
                        return [3 /*break*/, 4];
                    case 4:
                        this.onChangeCallback(this.value);
                        if (this.fileInput && this.fileInput.nativeElement) {
                            this.fileInput.nativeElement.value = '';
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @return {?}
     */
    BbImagePicker.prototype.openFilePicker = /**
     * @return {?}
     */
    function () {
        if (this.disabled) {
            return;
        }
        // Execute a click on the file input.
        this.fileInput
            && this.fileInput.nativeElement
            && this.fileInput.nativeElement.click
            && this.fileInput.nativeElement.click();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    BbImagePicker.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.value = value;
    };
    /**
     * @param {?} method
     * @return {?}
     */
    BbImagePicker.prototype.registerOnChange = /**
     * @param {?} method
     * @return {?}
     */
    function (method) {
        this.onChangeCallback = method;
    };
    /**
     * @param {?} method
     * @return {?}
     */
    BbImagePicker.prototype.registerOnTouched = /**
     * @param {?} method
     * @return {?}
     */
    function (method) {
        this.onTouchedCallback = method;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    BbImagePicker.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    BbImagePicker.decorators = [
        { type: Component, args: [{
                    selector: 'bb-image-picker',
                    template: "<!-- The input that can open the file picker. -->\n<input #fileInput\n       (change)=\"onFileChange($event)\"\n       class=\"bb-image-picker-input\"\n       type=\"file\"\n       tabindex=\"-1\"\n       accept=\"image/*\">\n\n<span [style.width]=\"styleDimensions?.width || '100%'\"\n      [style.height]=\"styleDimensions?.height || '215px'\"\n      [style.background-image]=\"image | async\"\n      class=\"bb-image-input-image\">\n    </span>\n\n<button *ngIf=\"label as labelText\"\n        (click)=\"openFilePicker()\"\n        bb-button\n        class=\"bb-image-input-button\"\n        type=\"button\">\n    {{ labelText }}\n</button>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        'class': 'bb-image-picker',
                        '[class.disabled]': 'disabled',
                        '[class.grouped]': 'grouped'
                    },
                    inputs: ['grouped', 'disabled'],
                    providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return BbImagePicker; })), multi: true }],
                    preserveWhitespaces: false,
                    styles: [".bb-image-picker{display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-direction:column;flex-direction:column}.bb-image-picker.circle>.bb-image-input-image{border-radius:50%}.bb-image-picker.grouped{margin-bottom:20px}.bb-image-picker.disabled{opacity:.5;cursor:default;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;pointer-events:none}.bb-image-picker-input{opacity:0;z-index:-1;width:.1px;height:.1px;overflow:hidden;position:absolute}.bb-image-input-image{display:-ms-flexbox;display:flex;cursor:default;position:relative;border-radius:4px;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;background:url(data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7) center center/cover no-repeat rgba(0,0,0,.2)}.bb-image-input-button{margin-top:10px}"]
                }] }
    ];
    /** @nocollapse */
    BbImagePicker.ctorParameters = function () { return [
        { type: ImageConverter }
    ]; };
    BbImagePicker.propDecorators = {
        fileInput: [{ type: ViewChild, args: ['fileInput', { static: true },] }],
        label: [{ type: Input }],
        placeholder: [{ type: Input }],
        styleDimensions: [{ type: Input }],
        cropDimensions: [{ type: Input }],
        value: [{ type: Input }],
        valueChange: [{ type: Output }]
    };
    return BbImagePicker;
}(BbImagePickerMixinBase));
if (false) {
    /** @type {?} */
    BbImagePicker.prototype.fileInput;
    /** @type {?} */
    BbImagePicker.prototype.label;
    /** @type {?} */
    BbImagePicker.prototype.placeholder;
    /** @type {?} */
    BbImagePicker.prototype.styleDimensions;
    /** @type {?} */
    BbImagePicker.prototype.cropDimensions;
    /**
     * @type {?}
     * @private
     */
    BbImagePicker.prototype._value$;
    /** @type {?} */
    BbImagePicker.prototype.valueChange;
    /** @type {?} */
    BbImagePicker.prototype.onTouchedCallback;
    /** @type {?} */
    BbImagePicker.prototype.onChangeCallback;
    /**
     * @type {?}
     * @private
     */
    BbImagePicker.prototype._converter;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var nextUniqueId = 0;
var BbFormControlBase = /** @class */ (function () {
    function BbFormControlBase() {
    }
    return BbFormControlBase;
}());
/** @type {?} */
var BbFormControlMixinBase = mixinDisabled(mixinFocused(mixinReadonly(mixinGrouped(mixinRequired(mixinError(BbFormControlBase))))));
var BbFormControl = /** @class */ (function (_super) {
    __extends(BbFormControl, _super);
    function BbFormControl(_errors) {
        var _this = _super.call(this) || this;
        _this._errors = _errors;
        // Inputs.
        _this.label = null;
        _this.hint = null;
        _this.customErrors = {};
        // Data.
        _this.arrow = false;
        _this._hideErrors = false;
        // Data.
        _this.labelId = "bb-form-control-" + nextUniqueId++;
        // Errors.
        _this.errors = new Subject();
        return _this;
    }
    Object.defineProperty(BbFormControl.prototype, "hideErrors", {
        get: /**
         * @return {?}
         */
        function () {
            return this._hideErrors;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._hideErrors = coerceBooleanProperty(value);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbFormControl.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.error$ = this.errors.pipe(map((/**
         * @param {?} errors
         * @return {?}
         */
        function (errors) {
            if (!errors || _this.hideErrors) {
                return null;
            }
            /** @type {?} */
            var token = Object.keys(errors)[0];
            /** @type {?} */
            var getError = _this.getDefaultError(token);
            /** @type {?} */
            var error = _this.customErrors[token] || (getError && getError(errors[token])) || null;
            return typeof error === 'string'
                ? { token: error }
                : error;
        })), tap((/**
         * @param {?} error
         * @return {?}
         */
        function (error) { return _this.error = !!error; })));
    };
    /**
     * @param {?} token
     * @return {?}
     */
    BbFormControl.prototype.getDefaultError = /**
     * @param {?} token
     * @return {?}
     */
    function (token) {
        /** @type {?} */
        var errors = (this._errors || []).reduce((/**
         * @param {?} previous
         * @param {?} current
         * @return {?}
         */
        function (previous, current) {
            return __assign({}, previous, current);
        }), {});
        return errors[token] || null;
    };
    BbFormControl.decorators = [
        { type: Component, args: [{
                    selector: 'bb-form-control',
                    template: "<!-- Label of the form control. -->\n<label *ngIf=\"label as labelContent\"\n       [attr.for]=\"labelId\"\n       class=\"bb-form-control-label\">\n    <ng-template [bbTemplate]=\"labelContent\">\n        {{ labelContent }}\n    </ng-template>\n</label>\n\n<!-- The input with the addons. -->\n<div class=\"bb-form-control-container\">\n    <ng-content select=\"[bbPrefix]\"></ng-content>\n    <ng-content select=\"[bbInput]\"></ng-content>\n    <ng-content select=\"[bbSuffix]\"></ng-content>\n</div>\n\n<!-- The form control error. -->\n<ng-container *ngIf=\"error$ | async as error; else hintTemplate\">\n    <p *ngIf=\"error?.token | bbLocalize:{optional: true, data: error?.data} as message\"\n       class=\"bb-form-control-error\">\n        {{ message }}\n    </p>\n</ng-container>\n\n<!-- The form control hint. -->\n<ng-template #hintTemplate>\n    <p *ngIf=\"hint as hintContent\"\n       class=\"bb-form-control-hint\">\n        <ng-template [bbTemplate]=\"hintContent\">\n            {{ hintContent }}\n        </ng-template>\n    </p>\n</ng-template>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        'class': 'bb-form-control',
                        '[class.readonly]': 'readonly',
                        '[class.required]': 'required',
                        '[class.disabled]': 'disabled',
                        '[class.focused]': 'focused',
                        '[class.grouped]': 'grouped',
                        '[class.arrow]': 'arrow',
                        '[class.error]': 'error'
                    },
                    inputs: ['grouped'],
                    preserveWhitespaces: false,
                    styles: [".bb-form-control{color:#2d3c4d;display:block}.bb-form-control>.bb-form-control-container>.bb-prefix,.bb-form-control>.bb-form-control-container>.bb-suffix{margin:0 8px;color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control.grouped{margin-bottom:20px}.bb-form-control.small{max-width:240px}.bb-form-control.medium{max-width:480px}.bb-form-control.large{max-width:720px}.bb-form-control.required>.bb-form-control-label:after{content:\"*\";color:#c23934;font-size:12px;line-height:1.5}.bb-form-control.disabled>.bb-form-control-container{cursor:default;pointer-events:none;background-color:rgba(204,204,204,.64)}.bb-form-control.disabled>.bb-form-control-container>input,.bb-form-control.disabled>.bb-form-control-container>select,.bb-form-control.disabled>.bb-form-control-container>textarea{color:#aaa}.bb-form-control.readonly>.bb-form-control-container{cursor:default;border:1px dotted #bdc4c9}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container{background-color:#fff;box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(0,123,255,.2)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input::-webkit-input-placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea::-webkit-input-placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input::-moz-placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea::-moz-placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input:-ms-input-placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea:-ms-input-placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input::-ms-input-placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea::-ms-input-placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>input::placeholder,.bb-form-control:not(.disabled):not(.readonly).focused>.bb-form-control-container>textarea::placeholder{color:#b4b4b4;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control.error>.bb-form-control-label{color:#c23934}.bb-form-control.error>.bb-form-control-container{border:1px solid #962b26;background-color:rgba(194,57,52,.25)!important;box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>.bb-prefix,.bb-form-control.error>.bb-form-control-container>.bb-suffix{color:#c23934}.bb-form-control.error>.bb-form-control-container>input::-webkit-input-placeholder,.bb-form-control.error>.bb-form-control-container>textarea::-webkit-input-placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>input::-moz-placeholder,.bb-form-control.error>.bb-form-control-container>textarea::-moz-placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>input:-ms-input-placeholder,.bb-form-control.error>.bb-form-control-container>textarea:-ms-input-placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>input::-ms-input-placeholder,.bb-form-control.error>.bb-form-control-container>textarea::-ms-input-placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.error>.bb-form-control-container>input::placeholder,.bb-form-control.error>.bb-form-control-container>textarea::placeholder{color:rgba(194,57,52,.4)!important}.bb-form-control.arrow>.bb-form-control-container:after{width:20px;content:\"\";height:36px;display:-ms-flexbox;display:flex;min-width:20px;background-repeat:no-repeat;background-position:calc(100% - 8px) center;background-image:url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAA0AAAAGCAYAAAAYLBS/AAAACXBIWXMAAAsSAAALEgHS3X78AAAAWUlEQVQYlY3QsQ2DMAAEwMMTsAkrZInvWY3WXiIjJJtkA1OBRCIRf/nSffFTrXXGE4uxbCXJBw+8R0CStcAg3JKsUI7mDzzBBd3AC4Cp9/4z21o7znl9A9gBAf4fpjLTwkUAAAAASUVORK5CYII=)}.bb-form-control-container{width:100%;display:-ms-flexbox;display:flex;overflow:hidden;position:relative;border-radius:3px;-ms-flex-align:center;align-items:center;border:1px solid #b6bbc1;background-color:#fff8ff;transition-duration:250ms;transition-property:background-color,box-shadow;transition-timing-function:cubic-bezier(0,0,.2,1);box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1)}.bb-form-control-container>input::-webkit-input-placeholder,.bb-form-control-container>textarea::-webkit-input-placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input::-moz-placeholder,.bb-form-control-container>textarea::-moz-placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input:-ms-input-placeholder,.bb-form-control-container>textarea:-ms-input-placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input::-ms-input-placeholder,.bb-form-control-container>textarea::-ms-input-placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input::placeholder,.bb-form-control-container>textarea::placeholder{color:#d2d2d2;transition:color .3s cubic-bezier(0,0,.2,1)}.bb-form-control-container>input,.bb-form-control-container>select,.bb-form-control-container>textarea{margin:0;width:100%;border:none;color:#3d464d;font-size:16px;-webkit-appearance:none;-moz-appearance:none;appearance:none;background-color:transparent}.bb-form-control-container>input,.bb-form-control-container>select{height:36px;padding:0 8px}.bb-form-control-container>select::-ms-expand{display:none}.bb-form-control-container>input::-ms-clear,.bb-form-control-container>input::-ms-reveal{width:0;height:0;display:none}.bb-form-control-container>input::-webkit-search-cancel-button,.bb-form-control-container>input::-webkit-search-decoration,.bb-form-control-container>input::-webkit-search-results-button,.bb-form-control-container>input::-webkit-search-results-decoration{display:none}.bb-form-control-container>textarea{resize:none;padding:8px}.bb-form-control-label{color:#000;display:block;position:relative;margin-bottom:4px;transition:color 30ms cubic-bezier(0,0,.2,1)}.bb-form-control-error,.bb-form-control-hint{display:block;font-size:13px;margin-top:4px}.bb-form-control-error{color:#c23934}.bb-form-control-hint{color:#738694}"]
                }] }
    ];
    /** @nocollapse */
    BbFormControl.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Optional }, { type: Inject, args: [ELEMENTS_ERRORS,] }] }
    ]; };
    BbFormControl.propDecorators = {
        label: [{ type: Input }],
        hint: [{ type: Input }],
        customErrors: [{ type: Input }],
        hideErrors: [{ type: Input }]
    };
    return BbFormControl;
}(BbFormControlMixinBase));
if (false) {
    /** @type {?} */
    BbFormControl.prototype.label;
    /** @type {?} */
    BbFormControl.prototype.hint;
    /** @type {?} */
    BbFormControl.prototype.customErrors;
    /** @type {?} */
    BbFormControl.prototype.arrow;
    /**
     * @type {?}
     * @private
     */
    BbFormControl.prototype._hideErrors;
    /** @type {?} */
    BbFormControl.prototype.labelId;
    /** @type {?} */
    BbFormControl.prototype.errors;
    /** @type {?} */
    BbFormControl.prototype.error$;
    /**
     * @type {?}
     * @private
     */
    BbFormControl.prototype._errors;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var nextUniqueId$1 = 0;
var BbFilePickerBase = /** @class */ (function () {
    function BbFilePickerBase() {
    }
    return BbFilePickerBase;
}());
/** @type {?} */
var BbFilePickerMixinBase = mixinDisabled(mixinGrouped(BbFilePickerBase));
var BbFilePicker = /** @class */ (function (_super) {
    __extends(BbFilePicker, _super);
    function BbFilePicker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // Inputs.
        _this.label = null;
        _this.accept = null;
        _this.showImages = true;
        // State.
        _this.labelId = "bb-file-picker-" + nextUniqueId$1++;
        _this.hovered = false;
        _this.value$ = new BehaviorSubject({});
        _this.valueChange = new EventEmitter();
        _this.onTouchedCallback = (/**
         * @return {?}
         */
        function () {
        });
        _this.onChangeCallback = (/**
         * @return {?}
         */
        function () {
        });
        _this.saveFile = (/**
         * @param {?=} files
         * @return {?}
         */
        function (files) {
            // Validate the files exist.
            if (!files) {
                return;
            }
            // Retrieve the first file.
            /** @type {?} */
            var file = files[0];
            // Validate the first file exists.
            if (!file) {
                return;
            }
            // Save the file.
            _this.value = file;
        });
        _this.getFileListFromEvent = (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var element = (/** @type {?} */ (event.target));
            if (!element) {
                return null;
            }
            return element.files;
        });
        _this.preventDefault = (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            event.preventDefault();
            event.stopPropagation();
        });
        return _this;
    }
    Object.defineProperty(BbFilePicker.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () {
            var file = this.value$.getValue().file;
            return file;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.value$.next({ file: value });
            this.valueChange.emit(value);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} event
     * @param {?} isHovered
     * @return {?}
     */
    BbFilePicker.prototype.onDrag = /**
     * @param {?} event
     * @param {?} isHovered
     * @return {?}
     */
    function (event, isHovered) {
        // Validate the input is not disabled.
        if (this.disabled) {
            return;
        }
        // Prevent the default event action
        // and start the hovering.
        this.preventDefault(event);
        this.hovered = isHovered;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BbFilePicker.prototype.onDrop = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // Validate the input is not disabled.
        if (this.disabled) {
            return;
        }
        // Prevent the default event action
        // and stop the hovering.
        this.preventDefault(event);
        this.hovered = false;
        // Save the file.
        this.saveFile(event['dataTransfer'].files);
        // Run the on change callback.
        this.onChangeCallback(this.value);
    };
    /**
     * @param {?=} file
     * @return {?}
     */
    BbFilePicker.prototype.onButtonPressed = /**
     * @param {?=} file
     * @return {?}
     */
    function (file) {
        if (file) {
            this.value = null;
            this.onChangeCallback(this.value);
            return;
        }
        return this.openFilePicker();
    };
    /**
     * @return {?}
     */
    BbFilePicker.prototype.openFilePicker = /**
     * @return {?}
     */
    function () {
        return this.fileInput
            && this.fileInput.nativeElement
            && this.fileInput.nativeElement.click
            && this.fileInput.nativeElement.click();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BbFilePicker.prototype.onFileChange = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // Validate the input is not disabled.
        if (this.disabled) {
            return;
        }
        // Extract the file from the event.
        /** @type {?} */
        var fileList = this.getFileListFromEvent(event);
        // Save the file.
        this.saveFile(fileList);
        // Run the on change callback.
        this.onChangeCallback(this.value);
        // Clear the file input.
        if (this.fileInput && this.fileInput.nativeElement) {
            this.fileInput.nativeElement.value = '';
        }
    };
    /**
     * @param {?} value
     * @return {?}
     */
    BbFilePicker.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this.value = value;
    };
    /**
     * @param {?} method
     * @return {?}
     */
    BbFilePicker.prototype.registerOnChange = /**
     * @param {?} method
     * @return {?}
     */
    function (method) {
        this.onChangeCallback = method;
    };
    /**
     * @param {?} method
     * @return {?}
     */
    BbFilePicker.prototype.registerOnTouched = /**
     * @param {?} method
     * @return {?}
     */
    function (method) {
        this.onTouchedCallback = method;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    BbFilePicker.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    BbFilePicker.decorators = [
        { type: Component, args: [{
                    selector: 'bb-file-picker',
                    template: "<!-- The label of the input. -->\n<label *ngIf=\"label as labelContent\"\n       [for]=\"labelId\"\n       class=\"bb-file-picker-label\">\n    <ng-template [bbTemplate]=\"labelContent\">\n        {{ labelContent }}\n    </ng-template>\n</label>\n\n<!-- The input that can open the file picker. -->\n<input #fileInput\n       [accept]=\"accept\"\n       [disabled]=\"disabled\"\n       (change)=\"onFileChange($event)\"\n       class=\"bb-file-picker-input\"\n       type=\"file\"\n       tabindex=\"-1\">\n\n<div *ngIf=\"value$ | async as data\"\n     class=\"bb-file-picker-wrapper\">\n    <!-- The button that accepts files. -->\n    <div class=\"bb-file-picker-container\">\n        <button [class.destructive]=\"!!data?.file\"\n                [disabled]=\"disabled\"\n                [id]=\"labelId\"\n                (click)=\"onButtonPressed(data?.file)\"\n                type=\"button\"\n                tabindex=\"-1\"\n                class=\"bb-file-picker-button\">\n            <ng-container *ngTemplateOutlet=\"data?.file ? closeIcon : uploadIcon\"></ng-container>\n            {{ (data?.file ? 'file-picker.remove' : 'file-picker.choose') | bbLocalize }}\n        </button>\n        <div class=\"bb-file-picker-zone\">\n            {{ 'file-picker.drop' | bbLocalize }}\n        </div>\n    </div>\n\n    <ng-container *ngIf=\"!!extraTemplate\">\n        <ng-container *ngTemplateOutlet=\"extraTemplate; context: {$implicit: data?.file}\"></ng-container>\n    </ng-container>\n\n    <ng-container *ngIf=\"showImages\">\n        <div *ngIf=\"data?.file | bbFileImage | async as image\"\n             class=\"bb-file-picker-image-container\">\n            <div class=\"bb-file-picker-image-wrapper\">\n                <div [@bbFilePickerImageAnimation]=\"true\"\n                     [style.padding-top.%]=\"image?.aspectRatio * 100\"\n                     [style.background-image]=\"image?.background\"\n                     class=\"bb-file-picker-image\">\n                </div>\n            </div>\n        </div>\n    </ng-container>\n\n    <!-- Extra information of the file. -->\n    <div [class.visible]=\"!!data?.file\"\n         class=\"bb-file-picker-info\">\n        <span *ngIf=\"data?.file?.name as name\">{{ name }}</span>\n        <span *ngIf=\"data?.file?.size as size\">{{ size | bbFileSize }}</span>\n    </div>\n</div>\n\n<!-- Upload icon. -->\n<ng-template #uploadIcon>\n    <svg xmlns=\"http://www.w3.org/2000/svg\"\n         class=\"bb-file-picker-icon\"\n         width=\"24\"\n         height=\"24\">\n        <path fill=\"currentColor\"\n              d=\"M2 12.5C2 9.46 4.46 7 7.5 7H18c2.21 0 4 1.79 4 4s-1.79 4-4 4H9.5a2.5 2.5 0 010-5H17v2H9.41c-.55 0-.55 1 0 1H18c1.1 0 2-.9 2-2s-.9-2-2-2H7.5C5.57 9 4 10.57 4 12.5S5.57 16 7.5 16H17v2H7.5C4.46 18 2 15.54 2 12.5z\"></path>\n        <path fill=\"none\" d=\"M0 0h24v24H0V0z\"></path>\n    </svg>\n</ng-template>\n\n<!-- Close icon. -->\n<ng-template #closeIcon>\n    <svg xmlns=\"http://www.w3.org/2000/svg\"\n         class=\"bb-file-picker-icon\"\n         width=\"24\"\n         height=\"24\">\n        <path fill=\"currentColor\"\n              d=\"M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z\"></path>\n        <path d=\"M0 0h24v24H0z\" fill=\"none\"></path>\n    </svg>\n</ng-template>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return BbFilePicker; })),
                            multi: true
                        }
                    ],
                    host: {
                        'class': 'bb-file-picker',
                        '[class.disabled]': 'disabled',
                        '[class.grouped]': 'grouped',
                        '[class.hovered]': 'hovered',
                        'tabindex': '0',
                        '(keyup.enter)': 'openFilePicker()'
                    },
                    animations: [
                        trigger('bbFilePickerImageAnimation', [
                            transition(':enter', [
                                style({ opacity: 0 }),
                                animate('200ms', style({ opacity: 1 }))
                            ]),
                            transition(':leave', [
                                animate('200ms', style({ opacity: 0 }))
                            ])
                        ])
                    ],
                    inputs: ['disabled', 'grouped'],
                    preserveWhitespaces: false,
                    styles: [".bb-file-picker{display:block}.bb-file-picker.disabled>.bb-file-picker-wrapper{cursor:default;background-color:rgba(204,204,204,.64)}.bb-file-picker.grouped{margin-bottom:20px}.bb-file-picker.full>.bb-file-picker-wrapper{width:100%}.bb-file-picker:not(.disabled) .bb-file-picker-button{background-color:#fff}.bb-file-picker:not(.disabled).hovered>.bb-file-picker-wrapper,.bb-file-picker:not(.disabled):focus>.bb-file-picker-wrapper{box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(0,123,255,.2)}.bb-file-picker-wrapper{max-width:100%;overflow:hidden;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;border-radius:3px;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-direction:column;flex-direction:column;border:1px solid #b6bbc1;background-color:#fff8ff;transition:box-shadow .2s cubic-bezier(0,0,.2,1);box-shadow:inset 0 3px 0 0 rgba(183,188,194,.2),0 6px 6px -6px rgba(0,0,0,.1)}.bb-file-picker-label{color:#000;display:block;position:relative;margin-bottom:4px}.bb-file-picker-input{opacity:0;z-index:-1;width:.1px;height:.1px;overflow:hidden;position:absolute}.bb-file-picker-container{overflow:hidden;min-height:38px;display:-ms-inline-flexbox;display:inline-flex}.bb-file-picker-button{margin:0;border:none;color:#2196f3;line-height:1;padding:0 12px;-webkit-appearance:none;-moz-appearance:none;appearance:none;font-weight:500;-ms-flex-align:center;align-items:center;white-space:nowrap;display:-ms-inline-flexbox;display:inline-flex;border-right:1px solid #b6bbc1;background-color:rgba(255,255,255,.5)}.bb-file-picker-button.destructive{color:#f55656}.bb-file-picker-icon{margin-right:4px}.bb-file-picker-zone{-ms-flex:1;flex:1;color:#848f99;font-size:14px;padding:8px 12px;line-height:18px;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-pack:center;justify-content:center}.bb-file-picker-info{height:0;color:#848f99;padding:0 12px;overflow:hidden;line-height:36px;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;background-color:#fff8ff;border-top:0 solid #b6bbc1;transition:height .2s cubic-bezier(0,0,.2,1)}.bb-file-picker-info.visible{height:38px;border-top-width:1px}.bb-file-picker-info>span{opacity:.4;max-width:100%;font-size:14px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis}.bb-file-picker-info>span:first-child{-ms-flex:1;flex:1}.bb-file-picker-info>span:last-child{margin-left:12px}.bb-file-picker-image-container{overflow:hidden;border-top:1px solid #b6bbc1}.bb-file-picker-image-wrapper{width:100%;max-width:40%;margin:20px auto}.bb-file-picker-image{width:100%;display:-ms-flexbox;display:flex;overflow:hidden;position:relative;border-radius:4px;will-change:opacity;background-size:cover;background-position:center;background-repeat:no-repeat}"]
                }] }
    ];
    BbFilePicker.propDecorators = {
        fileInput: [{ type: ViewChild, args: ['fileInput', { static: true },] }],
        extraTemplate: [{ type: ContentChild, args: ['extra', { static: false },] }],
        label: [{ type: Input }],
        accept: [{ type: Input }],
        showImages: [{ type: Input }],
        value: [{ type: Input }],
        valueChange: [{ type: Output }],
        onDrag: [{ type: HostListener, args: ['dragover', ['$event', 'true'],] }, { type: HostListener, args: ['dragleave', ['$event', 'false'],] }],
        onDrop: [{ type: HostListener, args: ['drop', ['$event'],] }]
    };
    return BbFilePicker;
}(BbFilePickerMixinBase));
if (false) {
    /** @type {?} */
    BbFilePicker.prototype.fileInput;
    /** @type {?} */
    BbFilePicker.prototype.extraTemplate;
    /** @type {?} */
    BbFilePicker.prototype.label;
    /** @type {?} */
    BbFilePicker.prototype.accept;
    /** @type {?} */
    BbFilePicker.prototype.showImages;
    /** @type {?} */
    BbFilePicker.prototype.labelId;
    /** @type {?} */
    BbFilePicker.prototype.hovered;
    /** @type {?} */
    BbFilePicker.prototype.value$;
    /** @type {?} */
    BbFilePicker.prototype.valueChange;
    /** @type {?} */
    BbFilePicker.prototype.onTouchedCallback;
    /** @type {?} */
    BbFilePicker.prototype.onChangeCallback;
    /**
     * @type {?}
     * @private
     */
    BbFilePicker.prototype.saveFile;
    /**
     * @type {?}
     * @private
     */
    BbFilePicker.prototype.getFileListFromEvent;
    /**
     * @type {?}
     * @private
     */
    BbFilePicker.prototype.preventDefault;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbSuffix = /** @class */ (function () {
    function BbSuffix() {
    }
    BbSuffix.decorators = [
        { type: Directive, args: [{
                    selector: '[bbSuffix]',
                    host: {
                        'class': 'bb-suffix'
                    }
                },] }
    ];
    return BbSuffix;
}());
var BbPrefix = /** @class */ (function () {
    function BbPrefix() {
    }
    BbPrefix.decorators = [
        { type: Directive, args: [{
                    selector: '[bbPrefix]',
                    host: {
                        'class': 'bb-prefix'
                    }
                },] }
    ];
    return BbPrefix;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbSelect = /** @class */ (function () {
    function BbSelect(_elementRef, _ngControl, _formControl, _form) {
        this._elementRef = _elementRef;
        this._ngControl = _ngControl;
        this._formControl = _formControl;
        this._form = _form;
        this.hasArrow = true;
        this._disabled = false;
        this._required = false;
    }
    /**
     * @return {?}
     */
    BbSelect.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this._subscription = merge(this.formSubmit, this.statusChanges, this.onFormReset).pipe(map((/**
         * @param {?} type
         * @return {?}
         */
        function (type) {
            /** @type {?} */
            var errors = _this._ngControl
                ? _this._ngControl.errors
                : null;
            // When the user submits always return the errors.
            if (type === 'form-submit') {
                return errors;
            }
            /** @type {?} */
            var isSubmitted = _this._form && _this._form.submitted;
            /** @type {?} */
            var isPristine = _this._form && _this._form.pristine;
            return isSubmitted && !isPristine
                ? errors
                : null;
        }))).subscribe((/**
         * @param {?} errors
         * @return {?}
         */
        function (errors) { return _this._formControl.errors.next(errors); }));
        // Set an arrow on the form control if
        // it requires one.
        this._formControl.arrow = this.hasArrow;
    };
    /**
     * @return {?}
     */
    BbSelect.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._subscription && this._subscription.unsubscribe();
    };
    /**
     * @return {?}
     */
    BbSelect.prototype.focus = /**
     * @return {?}
     */
    function () {
        return this._elementRef
            && this._elementRef.nativeElement
            && this._elementRef.nativeElement.focus
            && this._elementRef.nativeElement.focus();
    };
    /**
     * @param {?} hasFocus
     * @return {?}
     */
    BbSelect.prototype.setFocus = /**
     * @param {?} hasFocus
     * @return {?}
     */
    function (hasFocus) {
        if (!this._formControl) {
            return;
        }
        this._formControl.focused = hasFocus;
    };
    Object.defineProperty(BbSelect.prototype, "id", {
        get: /**
         * @return {?}
         */
        function () {
            return this._formControl && this._formControl.labelId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbSelect.prototype, "disabled", {
        get: /**
         * @return {?}
         */
        function () {
            if (this._ngControl && this._ngControl.disabled !== null) {
                return this._ngControl.disabled;
            }
            return this._disabled;
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this._disabled = coerceBooleanProperty(newValue);
            if (!this._formControl) {
                return;
            }
            this._formControl.disabled = this._disabled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbSelect.prototype, "required", {
        get: /**
         * @return {?}
         */
        function () {
            return this._required;
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this._required = coerceBooleanProperty(newValue);
            if (!this._formControl) {
                return;
            }
            this._formControl.required = this._required;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbSelect.prototype, "formSubmit", {
        get: /**
         * @private
         * @return {?}
         */
        function () {
            if (!this._form) {
                return EMPTY;
            }
            return this._form.ngSubmit.pipe(mapTo('form-submit'));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbSelect.prototype, "statusChanges", {
        get: /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            if (!this._ngControl) {
                return EMPTY;
            }
            return this._ngControl.statusChanges.pipe(delay(1), filter((/**
             * @return {?}
             */
            function () { return !_this._form ? true : !_this._form.pristine; })), mapTo('control-status-change'));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbSelect.prototype, "onFormReset", {
        get: /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            if (!this._form) {
                return EMPTY;
            }
            return this._form.valueChanges.pipe(delay(1), filter((/**
             * @return {?}
             */
            function () { return !_this._form ? true : !_this._form.pristine; })), mapTo('form-value-change'));
        },
        enumerable: true,
        configurable: true
    });
    BbSelect.decorators = [
        { type: Directive, args: [{
                    selector: 'select[bbInput]',
                    host: {
                        '[disabled]': 'disabled',
                        '(focus)': 'setFocus(true)',
                        '(blur)': 'setFocus(false)'
                    }
                },] }
    ];
    /** @nocollapse */
    BbSelect.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgControl, decorators: [{ type: Optional }] },
        { type: BbFormControl, decorators: [{ type: Optional }] },
        { type: FormGroupDirective, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    BbSelect.propDecorators = {
        id: [{ type: HostBinding, args: ['attr.id',] }],
        disabled: [{ type: Input }],
        required: [{ type: Input }]
    };
    return BbSelect;
}());
if (false) {
    /**
     * @type {?}
     * @protected
     */
    BbSelect.prototype.hasArrow;
    /**
     * @type {?}
     * @private
     */
    BbSelect.prototype._subscription;
    /**
     * @type {?}
     * @private
     */
    BbSelect.prototype._disabled;
    /**
     * @type {?}
     * @private
     */
    BbSelect.prototype._required;
    /**
     * @type {?}
     * @protected
     */
    BbSelect.prototype._elementRef;
    /**
     * @type {?}
     * @protected
     */
    BbSelect.prototype._ngControl;
    /**
     * @type {?}
     * @protected
     */
    BbSelect.prototype._formControl;
    /**
     * @type {?}
     * @protected
     */
    BbSelect.prototype._form;
}
var BbInput = /** @class */ (function (_super) {
    __extends(BbInput, _super);
    function BbInput(_elementRef, _ngControl, _formControl, _form) {
        var _this = _super.call(this, _elementRef, _ngControl, _formControl, _form) || this;
        _this._elementRef = _elementRef;
        _this._ngControl = _ngControl;
        _this._formControl = _formControl;
        _this._form = _form;
        _this.hasArrow = false;
        _this._readonly = false;
        return _this;
    }
    Object.defineProperty(BbInput.prototype, "readonly", {
        get: /**
         * @return {?}
         */
        function () {
            return this._readonly;
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this._readonly = coerceBooleanProperty(newValue);
            if (!this._formControl) {
                return;
            }
            this._formControl.readonly = this._readonly;
        },
        enumerable: true,
        configurable: true
    });
    BbInput.decorators = [
        { type: Directive, args: [{
                    selector: 'input[bbInput], textarea[bbInput]',
                    host: {
                        '[disabled]': 'disabled',
                        '[readonly]': 'readonly',
                        '(focus)': 'setFocus(true)',
                        '(blur)': 'setFocus(false)'
                    }
                },] }
    ];
    /** @nocollapse */
    BbInput.ctorParameters = function () { return [
        { type: ElementRef },
        { type: NgControl, decorators: [{ type: Optional }] },
        { type: BbFormControl, decorators: [{ type: Optional }] },
        { type: FormGroupDirective, decorators: [{ type: Optional }, { type: Host }] }
    ]; };
    BbInput.propDecorators = {
        readonly: [{ type: Input }]
    };
    return BbInput;
}(BbSelect));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    BbInput.prototype.hasArrow;
    /**
     * @type {?}
     * @private
     */
    BbInput.prototype._readonly;
    /**
     * @type {?}
     * @protected
     */
    BbInput.prototype._elementRef;
    /**
     * @type {?}
     * @protected
     */
    BbInput.prototype._ngControl;
    /**
     * @type {?}
     * @protected
     */
    BbInput.prototype._formControl;
    /**
     * @type {?}
     * @protected
     */
    BbInput.prototype._form;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbFormGroupBase = /** @class */ (function () {
    function BbFormGroupBase() {
    }
    return BbFormGroupBase;
}());
/** @type {?} */
var BbFormGroupMixinBase = mixinGrouped(BbFormGroupBase);
var BbFormGroup = /** @class */ (function (_super) {
    __extends(BbFormGroup, _super);
    function BbFormGroup() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BbFormGroup.decorators = [
        { type: Component, args: [{
                    selector: 'bb-form-group',
                    template: "<ng-content></ng-content>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        'class': 'bb-form-group',
                        '[class.grouped]': 'grouped'
                    },
                    inputs: ['grouped'],
                    preserveWhitespaces: false,
                    styles: [".bb-form-group{width:100%;display:-ms-flexbox;display:flex;-ms-flex-wrap:wrap;flex-wrap:wrap;margin-top:-10px}.bb-form-group>*{margin-top:10px}.bb-form-group>:not(:first-child){margin-left:10px}.bb-form-group.start{-ms-flex-pack:start;justify-content:flex-start}.bb-form-group.end{-ms-flex-pack:end;justify-content:flex-end}.bb-form-group.vertical{-ms-flex-direction:column;flex-direction:column;-ms-flex-pack:normal;justify-content:normal}.bb-form-group.vertical>*{margin-left:0}.bb-form-group.vertical.start{-ms-flex-align:start;align-items:flex-start}.bb-form-group.vertical.end{-ms-flex-align:end;align-items:flex-end}.bb-form-group.grouped{margin-bottom:20px}"]
                }] }
    ];
    return BbFormGroup;
}(BbFormGroupMixinBase));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbFocusTrap = /** @class */ (function () {
    function BbFocusTrap(_platform, _elementRef) {
        this._platform = _platform;
        this._elementRef = _elementRef;
        this._focusableElements = [
            'a[href]',
            'area[href]',
            'input:not([disabled]):not([type="hidden"]):not([aria-hidden])',
            'select:not([disabled]):not([aria-hidden])',
            'textarea:not([disabled]):not([aria-hidden])',
            'button:not([disabled]):not([aria-hidden])',
            'iframe',
            'object',
            'embed',
            '[contenteditable]',
            '[tabindex]:not([tabindex^="-"])'
        ];
        this.focus = (/**
         * @param {?} element
         * @return {?}
         */
        function (element) {
            return element && element.focus && element.focus();
        });
        this.isTabEvent = (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            return event.key === 'Tab' || event.keyCode === 9;
        });
    }
    /**
     * @param {?} event
     * @return {?}
     */
    BbFocusTrap.prototype.onKeydown = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // Validate it is a tab event.
        if (!this.isTabEvent(event)) {
            return;
        }
        // Trap the focus inside the element.
        return this.trapFocus(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BbFocusTrap.prototype.trapFocus = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // Validate that the DOM is available.
        if (!this._platform.isBrowser) {
            return;
        }
        // Get all focusable nodes.
        /** @type {?} */
        var focusableNodes = this.getFocusableNodes();
        // Focus the first available element if the focus
        // is not in the modal.
        if (!this.element.contains(document.activeElement)) {
            return this.focus(focusableNodes[0]);
        }
        /** @type {?} */
        var focusedItemIndex = focusableNodes.indexOf(document.activeElement);
        if (event.shiftKey && focusedItemIndex === 0) {
            this.focus(focusableNodes[focusableNodes.length - 1]);
            return event.preventDefault();
        }
        if (!event.shiftKey && focusedItemIndex === focusableNodes.length - 1) {
            this.focus(focusableNodes[0]);
            return event.preventDefault();
        }
    };
    Object.defineProperty(BbFocusTrap.prototype, "element", {
        get: /**
         * @private
         * @return {?}
         */
        function () {
            return this._elementRef.nativeElement;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @return {?}
     */
    BbFocusTrap.prototype.getFocusableNodes = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var nodes = this.element.querySelectorAll(this._focusableElements);
        return Array.apply(void 0, __spread(nodes));
    };
    BbFocusTrap.decorators = [
        { type: Directive, args: [{
                    selector: '[bbFocusTrap]'
                },] }
    ];
    /** @nocollapse */
    BbFocusTrap.ctorParameters = function () { return [
        { type: Platform },
        { type: ElementRef }
    ]; };
    BbFocusTrap.propDecorators = {
        onKeydown: [{ type: HostListener, args: ['keydown', ['$event'],] }]
    };
    return BbFocusTrap;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BbFocusTrap.prototype._focusableElements;
    /**
     * @type {?}
     * @private
     */
    BbFocusTrap.prototype.focus;
    /**
     * @type {?}
     * @private
     */
    BbFocusTrap.prototype.isTabEvent;
    /**
     * @type {?}
     * @private
     */
    BbFocusTrap.prototype._platform;
    /**
     * @type {?}
     * @private
     */
    BbFocusTrap.prototype._elementRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbButtonBase = /** @class */ (function () {
    function BbButtonBase(_elementRef) {
        this._elementRef = _elementRef;
    }
    return BbButtonBase;
}());
if (false) {
    /** @type {?} */
    BbButtonBase.prototype._elementRef;
}
/** @type {?} */
var BbButtonMixinBase = mixinDisabled(mixinLoad(BbButtonBase));
var BbButton = /** @class */ (function (_super) {
    __extends(BbButton, _super);
    function BbButton(_elementRef) {
        return _super.call(this, _elementRef) || this;
    }
    Object.defineProperty(BbButton.prototype, "nativeElement", {
        get: /**
         * @return {?}
         */
        function () {
            return this._elementRef.nativeElement;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbButton.prototype.focus = /**
     * @return {?}
     */
    function () {
        this.nativeElement && this.nativeElement.focus();
    };
    BbButton.decorators = [
        { type: Component, args: [{
                    selector: 'button[bb-button]',
                    template: "<bb-spinner [class.visible]=\"loading\"\n            class=\"bb-button-spinner small\">\n</bb-spinner>\n\n<ng-content></ng-content>\n",
                    exportAs: 'bbButton',
                    host: {
                        'class': 'bb-button',
                        '[class.loading]': 'loading',
                        '[attr.disabled]': 'disabled || loading || null'
                    },
                    inputs: ['disabled', 'loading'],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".bb-button{height:38px;padding:0 8px;cursor:pointer;font-size:16px;font-weight:500;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;position:relative;font-style:normal;border-radius:4px;text-align:center;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;text-decoration:none;-ms-flex-pack:center;justify-content:center;background-color:#fff;color:#2d3c4d!important;border:1px solid #d4d8e1;transition-duration:.2s;box-shadow:0 6px 6px -6px rgba(0,0,0,.1);transition-timing-function:cubic-bezier(0,0,.2,1);transition-property:padding-left,background-color,box-shadow}.bb-button:hover{background-color:#fcfcfb}.bb-button:active,.bb-button:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(220,224,233,.5)}.bb-button.full{width:100%}.bb-button.full.loading{padding-left:42px}.bb-button.primary{border-color:#2f2b85;color:#fff!important;background-color:#5b53ff}.bb-button.primary:hover{background-color:#564ee6}.bb-button.primary:active,.bb-button.primary:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(91,83,255,.5)}.bb-button.destructive{border-color:#8f2020;color:#fff!important;background-color:#d32f2f}.bb-button.destructive:hover{background-color:#c32929}.bb-button.destructive:active,.bb-button.destructive:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(211,47,47,.5)}.bb-button.loading,.bb-button.loading:active,.bb-button.loading:focus,.bb-button.loading:hover,.bb-button:disabled,.bb-button:disabled:active,.bb-button:disabled:focus,.bb-button:disabled:hover,.bb-button[disabled],.bb-button[disabled]:active,.bb-button[disabled]:focus,.bb-button[disabled]:hover{opacity:.4;cursor:default;box-shadow:none}.bb-button-spinner{width:0;opacity:0;overflow:hidden;visibility:hidden;padding:0!important;transition:width .2s cubic-bezier(0,0,.2,1),opacity .1s cubic-bezier(0,0,.2,1)}.bb-button-spinner.visible{opacity:1;width:20px;margin-right:8px;visibility:visible}.bb-button.loading.full>.bb-button-spinner{left:8px;margin-right:0;position:absolute}"]
                }] }
    ];
    /** @nocollapse */
    BbButton.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    return BbButton;
}(BbButtonMixinBase));
var BbAnchor = /** @class */ (function (_super) {
    __extends(BbAnchor, _super);
    function BbAnchor(_elementRef) {
        return _super.call(this, _elementRef) || this;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    BbAnchor.prototype.stopDisabledEvents = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // If the button is not disabled (and not loading) let all events pass.
        if (!this.disabled && !this.loading) {
            return;
        }
        // If the button is disabled and/or loading stop
        // the event from bubbling up.
        event.preventDefault();
        event.stopImmediatePropagation();
    };
    BbAnchor.decorators = [
        { type: Component, args: [{
                    selector: 'a[bb-button]',
                    template: "<bb-spinner [class.visible]=\"loading\"\n            class=\"bb-button-spinner small\">\n</bb-spinner>\n\n<ng-content></ng-content>\n",
                    exportAs: 'bbButton, bbAnchor',
                    host: {
                        'class': 'bb-button',
                        '[attr.tabindex]': '(disabled || loading) ? -1 : (tabIndex || 0)',
                        '[attr.disabled]': 'disabled || loading || null',
                        '[attr.aria-disabled]': '(disabled || loading).toString()',
                        '(click)': 'stopDisabledEvents($event)'
                    },
                    inputs: ['disabled'],
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".bb-button{height:38px;padding:0 8px;cursor:pointer;font-size:16px;font-weight:500;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;position:relative;font-style:normal;border-radius:4px;text-align:center;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;text-decoration:none;-ms-flex-pack:center;justify-content:center;background-color:#fff;color:#2d3c4d!important;border:1px solid #d4d8e1;transition-duration:.2s;box-shadow:0 6px 6px -6px rgba(0,0,0,.1);transition-timing-function:cubic-bezier(0,0,.2,1);transition-property:padding-left,background-color,box-shadow}.bb-button:hover{background-color:#fcfcfb}.bb-button:active,.bb-button:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(220,224,233,.5)}.bb-button.full{width:100%}.bb-button.full.loading{padding-left:42px}.bb-button.primary{border-color:#2f2b85;color:#fff!important;background-color:#5b53ff}.bb-button.primary:hover{background-color:#564ee6}.bb-button.primary:active,.bb-button.primary:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(91,83,255,.5)}.bb-button.destructive{border-color:#8f2020;color:#fff!important;background-color:#d32f2f}.bb-button.destructive:hover{background-color:#c32929}.bb-button.destructive:active,.bb-button.destructive:focus{box-shadow:0 6px 6px -6px rgba(0,0,0,.1),0 0 0 3px rgba(211,47,47,.5)}.bb-button.loading,.bb-button.loading:active,.bb-button.loading:focus,.bb-button.loading:hover,.bb-button:disabled,.bb-button:disabled:active,.bb-button:disabled:focus,.bb-button:disabled:hover,.bb-button[disabled],.bb-button[disabled]:active,.bb-button[disabled]:focus,.bb-button[disabled]:hover{opacity:.4;cursor:default;box-shadow:none}.bb-button-spinner{width:0;opacity:0;overflow:hidden;visibility:hidden;padding:0!important;transition:width .2s cubic-bezier(0,0,.2,1),opacity .1s cubic-bezier(0,0,.2,1)}.bb-button-spinner.visible{opacity:1;width:20px;margin-right:8px;visibility:visible}.bb-button.loading.full>.bb-button-spinner{left:8px;margin-right:0;position:absolute}"]
                }] }
    ];
    /** @nocollapse */
    BbAnchor.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    BbAnchor.propDecorators = {
        tabIndex: [{ type: Input }]
    };
    return BbAnchor;
}(BbButton));
if (false) {
    /** @type {?} */
    BbAnchor.prototype.tabIndex;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbTemplate = /** @class */ (function () {
    function BbTemplate(_templateRef, _viewContainerRef) {
        this._templateRef = _templateRef;
        this._viewContainerRef = _viewContainerRef;
    }
    Object.defineProperty(BbTemplate.prototype, "bbTemplate", {
        set: /**
         * @param {?} content
         * @return {?}
         */
        function (content) {
            // Get the template.
            /** @type {?} */
            var template = content instanceof TemplateRef
                ? content
                : this._templateRef;
            // Clear the view container ref and create the view.
            this._viewContainerRef.clear();
            this._viewContainerRef.createEmbeddedView(template);
        },
        enumerable: true,
        configurable: true
    });
    BbTemplate.decorators = [
        { type: Directive, args: [{
                    selector: '[bbTemplate]'
                },] }
    ];
    /** @nocollapse */
    BbTemplate.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    BbTemplate.propDecorators = {
        bbTemplate: [{ type: Input }]
    };
    return BbTemplate;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BbTemplate.prototype._templateRef;
    /**
     * @type {?}
     * @private
     */
    BbTemplate.prototype._viewContainerRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbAutosize = /** @class */ (function () {
    function BbAutosize(_renderer, _elementRef) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        // Min/max heights for the textarea.
        this.minHeight = null;
        this.maxHeight = null;
    }
    Object.defineProperty(BbAutosize.prototype, "element", {
        get: /**
         * @return {?}
         */
        function () {
            return this._elementRef.nativeElement;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbAutosize.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        // Update the styles after the DOM has loaded.
        this.updateStyles();
    };
    /**
     * @return {?}
     */
    BbAutosize.prototype.onWindowResize = /**
     * @return {?}
     */
    function () {
        // Update the styles when the window is resized.
        this.updateStyles();
    };
    /**
     * @return {?}
     */
    BbAutosize.prototype.onInputReceived = /**
     * @return {?}
     */
    function () {
        // Update the styles after the textarea received input.
        this.updateStyles();
    };
    /**
     * @private
     * @return {?}
     */
    BbAutosize.prototype.updateStyles = /**
     * @private
     * @return {?}
     */
    function () {
        // If the element does not exist exit.
        if (!this.element) {
            return;
        }
        // If the scroll height is the same height as the element, then exit.
        if (this.element.style.height === this.element.scrollHeight + 'px') {
            return;
        }
        // Set the style of the element to 'auto' to reset the element.
        this._renderer.setStyle(this.element, 'height', 'auto');
        // Set the style of the element to the scroll height to make
        // the element fit all the text.
        this._renderer.setStyle(this.element, 'height', this.element.scrollHeight + 'px');
    };
    BbAutosize.decorators = [
        { type: Directive, args: [{
                    selector: 'textarea[bbAutosize]'
                },] }
    ];
    /** @nocollapse */
    BbAutosize.ctorParameters = function () { return [
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    BbAutosize.propDecorators = {
        minHeight: [{ type: Input }, { type: HostBinding, args: ['style.min-height',] }],
        maxHeight: [{ type: Input }, { type: HostBinding, args: ['style.max-height',] }],
        onWindowResize: [{ type: HostListener, args: ['window:resize',] }],
        onInputReceived: [{ type: HostListener, args: ['input',] }]
    };
    return BbAutosize;
}());
if (false) {
    /** @type {?} */
    BbAutosize.prototype.minHeight;
    /** @type {?} */
    BbAutosize.prototype.maxHeight;
    /**
     * @type {?}
     * @private
     */
    BbAutosize.prototype._renderer;
    /**
     * @type {?}
     * @private
     */
    BbAutosize.prototype._elementRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var nextUniqueId$2 = 0;
var BbCheckboxBase = /** @class */ (function () {
    function BbCheckboxBase() {
    }
    return BbCheckboxBase;
}());
/** @type {?} */
var BbCheckboxMixinBase = mixinDisabled(mixinGrouped(BbCheckboxBase));
var BbCheckbox = /** @class */ (function (_super) {
    __extends(BbCheckbox, _super);
    function BbCheckbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // Data.
        _this.labelId = "bb-checkbox-" + nextUniqueId$2++;
        _this._checked = false;
        // Methods.
        _this.onChange = (/**
         * @return {?}
         */
        function () {
        });
        _this.onTouched = (/**
         * @return {?}
         */
        function () {
        });
        return _this;
    }
    Object.defineProperty(BbCheckbox.prototype, "checked", {
        get: /**
         * @return {?}
         */
        function () {
            return this._checked;
        },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value != this.checked) {
                this._checked = value;
                // this._changeDetection.markForCheck();
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} fn
     * @return {?}
     */
    BbCheckbox.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    BbCheckbox.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this.onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    BbCheckbox.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * @param {?} newValue
     * @return {?}
     */
    BbCheckbox.prototype.writeValue = /**
     * @param {?} newValue
     * @return {?}
     */
    function (newValue) {
        this.checked = newValue;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BbCheckbox.prototype.onInteractionEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // Stop the propagation to prevent it from bubbling up.
        event.stopPropagation();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    BbCheckbox.prototype.onInputClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // Stop the propagation to prevent it from bubbling up.
        event.stopPropagation();
        // Toggle the value.
        this.checked = !this.checked;
        // Emit the change event.
        this.onChange && this.onChange(this.checked);
    };
    BbCheckbox.decorators = [
        { type: Component, args: [{
                    selector: 'bb-checkbox',
                    template: "<input [id]=\"labelId\"\n       [checked]=\"checked\"\n       [disabled]=\"disabled\"\n       (change)=\"onInteractionEvent($event)\"\n       (click)=\"onInputClick($event)\"\n       class=\"bb-checkbox-input\"\n       type=\"checkbox\">\n\n<label [for]=\"labelId\"\n       class=\"bb-checkbox-label\">\n    <span>\n        <svg width=\"12px\"\n             height=\"10px\"\n             viewbox=\"0 0 12 10\">\n            <polyline points=\"1.5 6 4.5 9 10.5 1\"></polyline>\n        </svg>\n    </span>\n    <span>\n        <ng-content></ng-content>\n    </span>\n</label>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    providers: [
                        { provide: NG_VALUE_ACCESSOR, useExisting: forwardRef((/**
                             * @return {?}
                             */
                            function () { return BbCheckbox; })), multi: true }
                    ],
                    host: {
                        'class': 'bb-checkbox',
                        '[class.grouped]': 'grouped'
                    },
                    inputs: ['grouped', 'disabled'],
                    preserveWhitespaces: false,
                    styles: [".bb-checkbox{display:block}.bb-checkbox+.bb-checkbox{margin-top:5px}.bb-checkbox.grouped{margin-bottom:20px}.bb-checkbox-input{display:none}.bb-checkbox-label{margin:0;cursor:pointer;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.bb-checkbox-label>span{display:inline-block;vertical-align:middle;transform:translate3d(0,0,0)}.bb-checkbox-label>span:first-child{width:18px;height:18px;position:relative;border-radius:3px;vertical-align:middle;border:1px solid #bdc4c9;transition:.2s}.bb-checkbox-label>span:last-child{padding-left:8px}.bb-checkbox-label>span:first-child>svg{top:3px;left:2px;fill:none;stroke:#fff;stroke-width:2;position:absolute;stroke-linecap:round;stroke-linejoin:round;stroke-dasharray:16px;stroke-dashoffset:16px;transition:.3s;transform:translate3d(0,0,0)}.bb-checkbox-input:checked+.bb-checkbox-label>span:first-child{border-color:#5b53ff;background-color:#5b53ff}.bb-checkbox-input:checked+.bb-checkbox-label>span:first-child>svg{stroke-dashoffset:0}.bb-checkbox-input:disabled+.bb-checkbox-label{cursor:default;pointer-events:none}.bb-checkbox-input:disabled:checked+.bb-checkbox-label>span:first-child{border-color:rgba(204,204,204,.64);background-color:rgba(204,204,204,.64)}"]
                }] }
    ];
    BbCheckbox.propDecorators = {
        checked: [{ type: Input }]
    };
    return BbCheckbox;
}(BbCheckboxMixinBase));
if (false) {
    /** @type {?} */
    BbCheckbox.prototype.labelId;
    /**
     * @type {?}
     * @private
     */
    BbCheckbox.prototype._checked;
    /** @type {?} */
    BbCheckbox.prototype.onChange;
    /** @type {?} */
    BbCheckbox.prototype.onTouched;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbSpinnerBase = /** @class */ (function () {
    function BbSpinnerBase() {
    }
    return BbSpinnerBase;
}());
/** @type {?} */
var BbSpinnerMixinBase = mixinDisabled(BbSpinnerBase);
var BbSpinner = /** @class */ (function (_super) {
    __extends(BbSpinner, _super);
    function BbSpinner() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        // Inputs.
        _this.color = '#303f9f';
        _this.alt = 'Loading...';
        return _this;
    }
    BbSpinner.decorators = [
        { type: Component, args: [{
                    selector: 'bb-spinner',
                    template: "<!--\n    The spinner element.\n\n    This element contains a circle with a 25% bar that spins\n    indefinitely. The border color can be set via the \"color\"\n    property.\n-->\n<div class=\"bb-spinner-container\">\n    <div [style.border-left-color]=\"color\"\n         [class.disabled]=\"disabled\"\n         class=\"bb-spinner-loader\"\n         aria-live=\"assertive\"\n         role=\"alert\">\n        {{ alt }}\n    </div>\n    <ng-content select=\"img\"></ng-content>\n</div>\n\n<!--\n    The content of the spinner.\n\n    This element contains the content of the spinner. The user\n    can set the content inside the tag.\n-->\n<span class=\"bb-spinner-content\">\n    <ng-content></ng-content>\n</span>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    host: { 'class': 'bb-spinner' },
                    inputs: ['color', 'alt', 'disabled'],
                    preserveWhitespaces: false,
                    styles: [".bb-spinner{color:#565656;padding:20px 0;text-align:center;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-direction:column;flex-direction:column;-ms-flex-pack:center;justify-content:center}.bb-spinner.block{display:-ms-flexbox;display:flex}.bb-spinner.inverse .bb-spinner-loader{border-color:rgba(255,255,255,.15)}.bb-spinner.inverse .bb-spinner-content{color:rgba(255,255,255,.5)}.bb-spinner.small .bb-spinner-loader,.bb-spinner.small .bb-spinner-loader:after{width:20px;height:20px;min-width:20px;min-height:20px}.bb-spinner.small .bb-spinner-loader{border-width:2px}.bb-spinner.small .bb-spinner-content{font-size:12px}.bb-spinner.medium .bb-spinner-loader,.bb-spinner.medium .bb-spinner-loader:after{width:60px;height:60px;min-width:60px;min-height:60px}.bb-spinner.medium .bb-spinner-loader{border-width:4px}.bb-spinner.medium .bb-spinner-content{font-size:16px}.bb-spinner.large .bb-spinner-loader,.bb-spinner.large .bb-spinner-loader:after{width:100px;height:100px;min-width:100px;min-height:100px}.bb-spinner.large .bb-spinner-loader{border-width:6px}.bb-spinner.large .bb-spinner-content{font-size:20px}.bb-spinner.horizontal{text-align:left;-ms-flex-direction:row;flex-direction:row}.bb-spinner.horizontal .bb-spinner-content:not(:empty){margin-left:10px;margin-top:0}.bb-spinner.vertical{text-align:center;-ms-flex-direction:column;flex-direction:column}.bb-spinner.vertical .bb-spinner-content:not(:empty){margin-left:0;margin-top:10px}.bb-spinner-container{position:relative}.bb-spinner-container>img{top:20%;left:20%;width:60%;height:60%;position:absolute}.bb-spinner-loader{margin:0;padding:0;overflow:hidden;text-indent:100%;position:relative;display:inline-block;vertical-align:middle;border:4px solid #f2f4f6;-webkit-animation:1s linear infinite spin;animation:1s linear infinite spin}.bb-spinner-loader,.bb-spinner-loader:after{width:60px;height:60px;min-width:60px;min-height:60px;border-radius:50%}.bb-spinner-loader.disabled{cursor:default;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;pointer-events:none;-webkit-animation-play-state:paused;animation-play-state:paused}.bb-spinner-content:not(:empty){font-size:16px;margin-top:10px;font-weight:500}@-webkit-keyframes spin{from{transform:rotate(0)}to{transform:rotate(360deg)}}@keyframes spin{from{transform:rotate(0)}to{transform:rotate(360deg)}}"]
                }] }
    ];
    BbSpinner.propDecorators = {
        color: [{ type: Input }],
        alt: [{ type: Input }]
    };
    return BbSpinner;
}(BbSpinnerMixinBase));
if (false) {
    /** @type {?} */
    BbSpinner.prototype.color;
    /** @type {?} */
    BbSpinner.prototype.alt;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbFocus = /** @class */ (function () {
    function BbFocus(_zone, _platform, _elementRef) {
        this._zone = _zone;
        this._platform = _platform;
        this._elementRef = _elementRef;
    }
    Object.defineProperty(BbFocus.prototype, "nativeElement", {
        get: /**
         * @private
         * @return {?}
         */
        function () {
            return this._elementRef.nativeElement;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    BbFocus.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // Run the method outside the Angular zone.
        this._zone.runOutsideAngular((/**
         * @return {?}
         */
        function () { return _this.focus(); }));
    };
    /**
     * @private
     * @return {?}
     */
    BbFocus.prototype.focus = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        // Check if set timeout exists and the user is
        // using the site on desktop devices.
        if (!this._platform.isDesktop || !setTimeout) {
            return;
        }
        // Check if the element and the focus method exist, if so focus the element.
        if (!this.nativeElement || !this.nativeElement.focus) {
            return;
        }
        // Execute the focus method in a timeout.
        setTimeout((/**
         * @return {?}
         */
        function () { return _this.nativeElement.focus(); }), 0);
    };
    BbFocus.decorators = [
        { type: Directive, args: [{
                    selector: '[bbFocus]'
                },] }
    ];
    /** @nocollapse */
    BbFocus.ctorParameters = function () { return [
        { type: NgZone },
        { type: Platform },
        { type: ElementRef }
    ]; };
    return BbFocus;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BbFocus.prototype._zone;
    /**
     * @type {?}
     * @private
     */
    BbFocus.prototype._platform;
    /**
     * @type {?}
     * @private
     */
    BbFocus.prototype._elementRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbFileImage = /** @class */ (function () {
    function BbFileImage(_image, _sanitizer) {
        this._image = _image;
        this._sanitizer = _sanitizer;
    }
    /**
     * @param {?} file
     * @return {?}
     */
    BbFileImage.prototype.transform = /**
     * @param {?} file
     * @return {?}
     */
    function (file) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                // If the file is not a file return.
                if (!(file instanceof File)) {
                    return [2 /*return*/, null];
                }
                return [2 /*return*/, this._image.fileToImage(file, [
                        'image/png',
                        'image/jpeg',
                        'image/gif',
                        'image/svg+xml'
                    ]).then((/**
                     * @param {?} image
                     * @return {?}
                     */
                    function (image) {
                        if (!image) {
                            return null;
                        }
                        return {
                            background: _this._sanitizer.bypassSecurityTrustStyle("url(" + image.src + ")"),
                            aspectRatio: image.height / image.width
                        };
                    })).catch((/**
                     * @return {?}
                     */
                    function () {
                        return null;
                    }))];
            });
        });
    };
    BbFileImage.decorators = [
        { type: Pipe, args: [{
                    name: 'bbFileImage'
                },] }
    ];
    /** @nocollapse */
    BbFileImage.ctorParameters = function () { return [
        { type: ImageConverter },
        { type: DomSanitizer }
    ]; };
    return BbFileImage;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BbFileImage.prototype._image;
    /**
     * @type {?}
     * @private
     */
    BbFileImage.prototype._sanitizer;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbFileSize = /** @class */ (function () {
    function BbFileSize() {
        this.format = (/**
         * @param {?} value
         * @param {?=} decimals
         * @return {?}
         */
        function (value, decimals) {
            if (decimals === void 0) { decimals = 2; }
            if (value === 0) {
                return '0 Bytes';
            }
            /** @type {?} */
            var k = 1024;
            /** @type {?} */
            var dm = decimals < 0 ? 0 : decimals;
            /** @type {?} */
            var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
            /** @type {?} */
            var index = Math.floor(Math.log(value) / Math.log(k));
            return parseFloat((value / Math.pow(k, index)).toFixed(dm)) + ' ' + sizes[index];
        });
    }
    /**
     * @param {?} value
     * @return {?}
     */
    BbFileSize.prototype.transform = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return this.format(value);
    };
    BbFileSize.decorators = [
        { type: Pipe, args: [{
                    name: 'bbFileSize'
                },] }
    ];
    return BbFileSize;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BbFileSize.prototype.format;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbIcon = /** @class */ (function () {
    function BbIcon(_registry) {
        this._registry = _registry;
        // Data.
        this._src = null;
        // State.
        this.state$ = new BehaviorSubject(null);
        this.alt = null;
        this.size = 24;
        this._ariaHidden = true;
        this.warn = (/**
         * @param {?} content
         * @return {?}
         */
        function (content) {
            return console && console.warn && console.warn(content);
        });
    }
    Object.defineProperty(BbIcon.prototype, "src", {
        get: /**
         * @return {?}
         */
        function () {
            return this._src;
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this.state$.next(this.convert(newValue));
            this._src = newValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BbIcon.prototype, "ariaHidden", {
        get: /**
         * @return {?}
         */
        function () {
            return this._ariaHidden;
        },
        set: /**
         * @param {?} newValue
         * @return {?}
         */
        function (newValue) {
            this._ariaHidden = coerceBooleanProperty(newValue);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @param {?} src
     * @return {?}
     */
    BbIcon.prototype.convert = /**
     * @private
     * @param {?} src
     * @return {?}
     */
    function (src) {
        var _this = this;
        var _a = __read((src || '').split(':'), 2), namespace = _a[0], value = _a[1];
        /** @type {?} */
        var onError = (/**
         * @return {?}
         */
        function () {
            _this.warn("ElementsModule: The icon with src \"" + src + "\" could not be rendered correctly; Did you put a correct src attribute?");
            return { type: 'unknown' };
        });
        if (!namespace || !value || !this._registry) {
            return onError();
        }
        // Try to find a image icon.
        /** @type {?} */
        var imageIcon = this.findImageIcon(namespace, value);
        if (imageIcon) {
            return imageIcon;
        }
        // Try to find a font icon.
        /** @type {?} */
        var fontIcon = this.findFontIcon(namespace, value);
        if (fontIcon) {
            return fontIcon;
        }
        // Return the on error function.
        return onError();
    };
    /**
     * @private
     * @param {?} namespace
     * @param {?} value
     * @return {?}
     */
    BbIcon.prototype.findImageIcon = /**
     * @private
     * @param {?} namespace
     * @param {?} value
     * @return {?}
     */
    function (namespace, value) {
        /** @type {?} */
        var data = this._registry.find((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item['namespace'] === namespace && item['name'] === value; }));
        if (!data) {
            return null;
        }
        return { type: data['type'], src: data['src'] };
    };
    /**
     * @private
     * @param {?} namespace
     * @param {?} content
     * @return {?}
     */
    BbIcon.prototype.findFontIcon = /**
     * @private
     * @param {?} namespace
     * @param {?} content
     * @return {?}
     */
    function (namespace, content) {
        /** @type {?} */
        var data = this._registry.find((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item['namespace'] === namespace; }));
        if (!data) {
            return null;
        }
        /** @type {?} */
        var isInline = data['inline'] || false;
        if (isInline) {
            return { type: data['type'], className: "" + data['className'] + content };
        }
        return { type: data['type'], className: data['className'], content: content };
    };
    BbIcon.decorators = [
        { type: Component, args: [{
                    selector: 'bb-icon',
                    template: "<ng-container *ngIf=\"state$ | async as data\"\n              [ngSwitch]=\"data?.type\">\n    <i *ngSwitchCase=\"'font'\"\n       [class]=\"data?.className\">\n        {{ data?.content }}\n    </i>\n    <img *ngSwitchCase=\"'image'\"\n         [src]=\"data?.src\"\n         [alt]=\"alt\">\n    <svg *ngSwitchCase=\"'unknown'\"\n         viewBox=\"0 0 1 1\">\n        <rect x=\"0\" y=\"0\" width=\"1\" height=\"1\" fill=\"#c5c5c5\"></rect>\n    </svg>\n</ng-container>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        'class': 'bb-icon',
                        '[attr.aria-hidden]': 'ariaHidden',
                        '[style.width.px]': 'size',
                        '[style.height.px]': 'size',
                        '[style.min-width.px]': 'size',
                        '[style.min-height.px]': 'size'
                    },
                    preserveWhitespaces: false,
                    styles: [".bb-icon{display:-ms-flexbox;display:flex;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center}.bb-icon>img,.bb-icon>svg{width:100%;height:100%;display:-ms-flexbox;display:flex}"]
                }] }
    ];
    /** @nocollapse */
    BbIcon.ctorParameters = function () { return [
        { type: Array, decorators: [{ type: Optional }, { type: Inject, args: [ELEMENTS_ICONS,] }] }
    ]; };
    BbIcon.propDecorators = {
        alt: [{ type: Input }],
        size: [{ type: Input }],
        src: [{ type: Input }],
        ariaHidden: [{ type: Input }]
    };
    return BbIcon;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    BbIcon.prototype._src;
    /** @type {?} */
    BbIcon.prototype.state$;
    /** @type {?} */
    BbIcon.prototype.alt;
    /** @type {?} */
    BbIcon.prototype.size;
    /**
     * @type {?}
     * @private
     */
    BbIcon.prototype._ariaHidden;
    /**
     * @type {?}
     * @private
     */
    BbIcon.prototype.warn;
    /**
     * @type {?}
     * @private
     */
    BbIcon.prototype._registry;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BbTag = /** @class */ (function () {
    function BbTag() {
        // Outputs.
        this.onClose = new EventEmitter();
    }
    BbTag.decorators = [
        { type: Component, args: [{
                    selector: 'bb-tag',
                    template: "<ng-content></ng-content>\n\n<button *ngIf=\"onClose?.observers?.length > 0\"\n        (click)=\"onClose.emit()\"\n        type=\"button\">\n    Close\n</button>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    encapsulation: ViewEncapsulation.None,
                    preserveWhitespaces: false,
                    host: { 'class': 'bb-tag' },
                    styles: [".bb-tag{cursor:default;padding:0 7px;font-size:12px;list-style:none;line-height:20px;border-radius:4px;white-space:nowrap;display:inline-block;color:rgba(0,0,0,.65);border:1px solid #d9d9d9;background-color:#fafafa;font-variant:tabular-nums;-webkit-font-feature-settings:\"tnum\";font-feature-settings:\"tnum\"}.bb-tag:not(:last-child){margin-right:8px}"]
                }] }
    ];
    BbTag.propDecorators = {
        onClose: [{ type: Output }]
    };
    return BbTag;
}());
if (false) {
    /** @type {?} */
    BbTag.prototype.onClose;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var DECLARATIONS_EXPORTS = [
    // Directives.
    BbTemplate,
    BbInput,
    BbSelect,
    BbFocus,
    BbFocusTrap,
    BbAutosize,
    BbPrefix,
    BbSuffix,
    // Pipes.
    BbFileSize,
    BbFileImage,
    // Components.
    BbButton,
    BbAnchor,
    BbSpinner,
    BbIcon,
    BbFormControl,
    BbFormGroup,
    BbCheckbox,
    BbImagePicker,
    BbDropdown,
    BbDropdownItem,
    BbTag,
    BbFilePicker
];
var ElementsModule = /** @class */ (function () {
    function ElementsModule() {
    }
    /**
     * @return {?}
     */
    ElementsModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: ElementsModule,
            providers: [
                { provide: ELEMENTS_ERRORS, useFactory: getErrors, multi: true },
                ELEMENTS_MATERIAL_ICON
            ]
        };
    };
    ElementsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, LocalizeModule],
                    declarations: __spread(DECLARATIONS_EXPORTS),
                    exports: __spread(DECLARATIONS_EXPORTS)
                },] }
    ];
    return ElementsModule;
}());
var ɵ0 = { namespace: 'material', className: 'material-icons', type: 'font' };
/** @type {?} */
var ELEMENTS_MATERIAL_ICON = {
    provide: ELEMENTS_ICONS,
    useValue: ɵ0,
    multi: true
};
/**
 * @return {?}
 */
function getErrors() {
    /** @type {?} */
    var data = {
        required: (/**
         * @return {?}
         */
        function () { return 'form-control-errors.required'; }),
        pattern: (/**
         * @return {?}
         */
        function () { return 'form-control-errors.pattern'; }),
        email: (/**
         * @return {?}
         */
        function () { return 'form-control-errors.email'; }),
        fullNumber: (/**
         * @return {?}
         */
        function () { return 'form-control-errors.fullNumber'; }),
        min: (/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var min = _a.min;
            return ({ token: 'form-control-errors.min', data: { min: min } });
        }),
        max: (/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var max = _a.max;
            return ({ token: 'form-control-errors.max', data: { max: max } });
        }),
        minlength: (/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var requiredLength = _a.requiredLength, actualLength = _a.actualLength;
            return ({
                token: 'form-control-errors.minlength',
                data: { requiredLength: requiredLength, actualLength: actualLength }
            });
        }),
        maxlength: (/**
         * @param {?} __0
         * @return {?}
         */
        function (_a) {
            var requiredLength = _a.requiredLength, actualLength = _a.actualLength;
            return ({
                token: 'form-control-errors.maxlength',
                data: { requiredLength: requiredLength, actualLength: actualLength }
            });
        })
    };
    return data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BbAnchor, BbAutosize, BbButton, BbCheckbox, BbFileImage, BbFilePicker, BbFileSize, BbFocus, BbFocusTrap, BbFormControl, BbFormGroup, BbIcon, BbInput, BbPrefix, BbSelect, BbSpinner, BbSuffix, BbTag, BbTemplate, ELEMENTS_MATERIAL_ICON, ElementsModule, getErrors, ELEMENTS_ICONS as ɵa, ELEMENTS_ERRORS as ɵb, BbImagePicker as ɵe, BbDropdown as ɵf, BbDropdownItem as ɵg };
//# sourceMappingURL=bravobit-bb-foundation-elements.js.map
